// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITree;
import org.apache.myfaces.tobago.model.Selectable;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/**
 A tree with classical look.
  Usually used with icons and junction lines to open folder, etc.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeTagDeclaration}.
 */
@Generated("component.stg")
public class UITree
    extends AbstractUITree implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.tree;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "javax.faces.Data";


  enum PropertyKeys {
    showRoot,
    markup,
    showRootJunction,
    selectable,
    customClass,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Only applicable in the case that the data model is a tree.
   This flag indicates that the root node should be displayed.
   Often in tree structures the root node is special and should not be displayed.
  <br>Default: <code>false</code>
  */
  public boolean isShowRoot() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showRoot);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowRoot(boolean showRoot) {
    getStateHelper().put(PropertyKeys.showRoot, showRoot);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Only applicable in the case that the data model is a tree.
   This flag indicates that the root node should be displayed with an open-close-switch.
  <br>Default: <code>false</code>
  */
  public boolean isShowRootJunction() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showRootJunction);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowRootJunction(boolean showRootJunction) {
    getStateHelper().put(PropertyKeys.showRootJunction, showRootJunction);
  }

  /**
  Flag indicating whether or not this component should be render selectable items.
   Possible values are:
   <ul>
   <li><strong>none</strong> : not selectable</li>
   <li><strong>multi</strong> : a multi section tree is rendered</li>
   <li><strong>single</strong> : a single section tree is rendered</li>
   <li><strong>multiLeafOnly</strong> : a multi section tree is rendered,
   only leaf's are selectable</li>
   <li><strong>singleLeafOnly</strong> : a single section tree is rendered,
   only leaf's are selectable</li>
   </ul>
  <br>Default: <code>multi</code><br>Allowed Values: <code>none,multi,single,multiLeafOnly,singleLeafOnly</code>
  */
  public org.apache.myfaces.tobago.model.Selectable getSelectable() {
    org.apache.myfaces.tobago.model.Selectable selectable = (org.apache.myfaces.tobago.model.Selectable) getStateHelper().eval(PropertyKeys.selectable);
    if (selectable != null) {
      return selectable;
    }
    return org.apache.myfaces.tobago.model.Selectable.multi;
  }

  public void setSelectable(org.apache.myfaces.tobago.model.Selectable selectable) {
    getStateHelper().put(PropertyKeys.selectable, selectable);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}